#include <iostream>

using namespace std;

int main()
{
    int t;
    cin>>t;
    for(int i=0;i<t;i++){
        int n,m;
        cin>>n>>m;
        long long int a[n];
        for(int j=0;j<n;j++)
            cin>>a[j];
        long long int b[m];
        for(int j=0;j<m;j++)
            cin>>b[j];

        if(n == 2){
            cout<<1<<endl;
            continue;
        }
        for(int j=0;j<n-1;j++)
            for(int k=0; k<n-j-1;k++){
                if(a[k]>a[k+1]){
                    long long int pom = a[k];
                    a[k] = a[k+1];
                    a[k+1] = pom;
                }
            }
        int postoji = 1;
        int index = 2;
        long long int broj = a[1];
        long long int razlika = a[1] - a[0];
        while(index < n && broj < a[index]){
            broj += razlika;
            if(broj == a[index])
                index++;
            else if(broj > a[index]){
                if(razlika % 2 != 0){
                    postoji = 0;
                    break;
                }else{
                    int pronadjeno = 0;
                    int counter = 0;
                    while(razlika % 2 == 0 && counter < 4){
                        counter++;
                        razlika /= 2;
                        if(broj - razlika == a[index]){
                            broj -= razlika;
                            index++;
                            pronadjeno = 1;
                            break;
                        }else if(broj - razlika > a[index]){
                            broj -= razlika;
                        }else if(broj < a[index]){
                            broj += razlika;
                        }
                    }
                    if(pronadjeno == 0){
                        postoji = 0;
                        break;
                    }
                }
            }else{
                for(int j=0;j<m;j++){
                    if(broj == b[j]){
                        postoji = 0;
                        break;
                    }
                }
            }
        }
        cout<<postoji<<endl;
    }
    return 0;
}